﻿using AdventOfCode._2022.Models;
using AdventOfCode.Common;
using AdventOfCode.Models;
using System;
using System.Linq;

namespace AdventOfCode._2022.Day9
{
    [AOC(year: 2022, day: 9)]
    public class Day9 : AOCDay
    {
        protected override AOCResponse ExecutePartA()
        {
            var rope = new Rope(1);
            foreach (var line in GetSplitInput())
            {
                var direction = Enum.Parse<Direction>(line.Split(" ")[0]);
                var count = int.Parse(line.Split(" ")[1]);
                rope.Move(direction, count);
            }
            _response.Answer = rope.GetUniqueVisitedByTail();
            return _response;
        }

        protected override AOCResponse ExecutePartB()
        {
            var rope = new Rope(9);
            foreach (var line in GetSplitInput())
            {
                var direction = Enum.Parse<Direction>(line.Split(" ")[0]);
                var count = int.Parse(line.Split(" ")[1]);
                rope.Move(direction, count);
            }
            _response.Answer = rope.GetUniqueVisitedByTail();
            return _response;
        }
    }
}
